ncalogd revision 7c478bd95313f5f23a4c958a745db2134aa03244
#!/sbin/sh
#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License, Version 1.0 only
# (the "License"). You may not use this file except in compliance
# with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright (c) 1998-2001 by Sun Microsystems, Inc.
# All rights reserved.
#
#ident "%Z%%M% %I% %E% SMI"
# Default location for script
ncalogd=/etc/init.d/ncalogd
success=1
# Default config values used by script
ncalogdconf=/etc/nca/ncalogd.conf
ncakmodconf=/etc/nca/ncakmod.conf
isValidFile() {
# Check if file exists
if [ ! -f $1 ]
then
# Create subdirectories
logd_dir=`/usr/bin/dirname $1`
if [ ! -d "$logd_dir" ]; then
/usr/bin/mkdir -m 0755 -p $logd_dir > /dev/null 2>&1
if [ $? != 0 ]; then
echo "Error: $ncalogd: unable to" \
"create directory $logd_dir"
return 1
fi
fi
# Create the log file
touch $1
if [ $? != 0 ]; then
echo "Error: ${ncalogd}: unable to create file $1"
return 1
fi
fi
# test if valid local file
df -l $1 > /dev/null 2>&1
if [ $? != 0 ]; then
echo "Error: $ncalogd: $1 is not a local file system"
return 1
fi
return 0
}
isValidDev() {
# Check if device is valid
fsck -m $1 > /dev/null 2>&1
case $? in
36 | 39 )
return 0
;;
0 | 32 | 33 | 40 )
echo "Error: $ncalogd: refusing to overwrite filesystem on $1"
return 1
;;
* )
echo "Error: $ncalogd: $1 is an invalid device"
return 1
;;
esac
}
case "$1" in
'start')
if [ ! -f $ncalogdconf ]; then
# If configuration file is missing, just exit
exit 0
fi
. $ncalogdconf
# Default is "disabled" so we want to exit
[ "x$status" != "xenabled" ] && exit 0
. $ncakmodconf
# Default is "disabled" so we want to exit
[ "x$status" != "xenabled" ] && exit 0
for i in $logd_path_name; do
# make sure that specified logfile is not a directory
if [ -d $i ]; then
echo "Error: $ncalogd: $i is a directory"
continue
elif [ -b $i -o -c $i ]; then
# Check if file is a device
isValidDev $i || continue
else
isValidFile $i || continue
fi
# Finally, set the specified file as a NCA log file
/usr/sbin/ndd -set /dev/nca nca_log_file $i
success=0
done
if [ $success = 0 ]; then
[ "x$logd_file_size" != "x" ] && \
/usr/sbin/ndd -set /dev/nca nca_log_size $logd_file_size
/usr/sbin/ndd -set /dev/nca nca_logging_on 1
fi
;;
'stop')
. $ncakmodconf
if [ "x$status" = "xenabled" ]; then
/usr/sbin/ndd -set /dev/nca nca_logging_on 0
fi
;;
*)
echo "Usage: $0 { start | stop }"
exit 1
;;
esac
exit 0